# AiurVersionControl

[![Pipeline stat](https://gitlab.aiursoft.cn/aiursoft/aiurversioncontrol/badges/master/pipeline.svg)](https://gitlab.aiursoft.cn/aiursoft/aiurversioncontrol/-/pipelines)
[![Test Coverage](https://gitlab.aiursoft.cn/aiursoft/aiurversioncontrol/badges/master/coverage.svg)](https://gitlab.aiursoft.cn/aiursoft/aiurversioncontrol/-/pipelines)
[![NuGet version](https://img.shields.io/nuget/v/Aiursoft.AiurVersionControl.svg?style=flat-square)](https://www.nuget.org/packages/Aiursoft.AiurVersionControl/)
[![ManHours](https://manhours.aiursoft.cn/r/gitlab.aiursoft.cn/aiursoft/aiurversioncontrol.svg)](https://gitlab.aiursoft.cn/aiursoft/aiurversioncontrol/-/commits/master?ref_type=heads)

A powerful collection sync framework that powers Kahla.

## Install

| Name                       | Download                                                                                                                                                                                     | Description                                                                        |
|----------------------------|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|------------------------------------------------------------------------------------|
| Aiursoft.AiurVersionControl         | [![NuGet version (Aiursoft.AiurVersionControl)](https://img.shields.io/nuget/v/Aiursoft.AiurVersionControl.svg?style=flat-square)](https://www.nuget.org/packages/Aiursoft.AiurVersionControl/)                         | An event repro engine which helps generate final workspace from commit history.    |
| Aiursoft.AiurEventSyncer.WebExtends | [![NuGet version (Aiursoft.AiurEventSyncer.WebExtends)](https://img.shields.io/nuget/v/Aiursoft.AiurEventSyncer.WebExtends.svg?style=flat-square)](https://www.nuget.org/packages/Aiursoft.AiurEventSyncer.WebExtends/) | WebSocket protocol server side support for AiurEventSyncer.                        |
| Aiursoft.AiurEventSyncer            | [![NuGet version (Aiursoft.AiurEventSyncer)](https://img.shields.io/nuget/v/Aiursoft.AiurEventSyncer.svg?style=flat-square)](https://www.nuget.org/packages/Aiursoft.AiurEventSyncer/)                                  | A commits sync framework which achieves final consistency and always availability. |
| Aiursoft.AiurStore                  | [![NuGet version (Aiursoft.AiurStore)](https://img.shields.io/nuget/v/Aiursoft.AiurStore.svg?style=flat-square)](https://www.nuget.org/packages/Aiursoft.AiurStore/)                                                    | An abstract database layer which describes a immutable data storage.               |

## Run locally

Requirements about how to run

1. [.NET 8 SDK](http://dot.net/)
2. Execute `dotnet run` to run the app

## Run in Microsoft Visual Studio

1. Open the `.sln` file in the project path.
2. Press `F5`.

## How to contribute

There are many ways to contribute to the project: logging bugs, submitting pull requests, reporting issues, and creating suggestions.

Even if you with push rights on the repository, you should create a personal fork and create feature branches there when you need them. This keeps the main repository clean and your workflow cruft out of sight.

We're also interested in your feedback on the future of this project. You can submit a suggestion or feature request through the issue tracker. To make this process more effective, we're asking that these include more information to help define them more clearly.
